# ویرایشگر ساعات کار برای اوپن‌استریت‌مپ

تعاریف فنی ساعت کاری در اوپن‌استریت‌مپ نسبتاً پیچیده است و ارائهٔ آن در قالب یک واسط کاربری سرراست و ساده چندان آسان و سهل نیست.

البته بیشتر اوقات معمولاً فقط بخش کوچکی از تعاریف نیازتان می‌شود. این ویرایشگر با در نظر گرفتن همین موضوع، قابلیت‌های پیچیده‌تر را در منوها پنهان می‌کند و بیشتر وقت‌ها برای کاربردهای معمول به اندکی دستکاری در الگوهای ازپیش‌تعریف‌شده نیاز دارید.

_این سند مقدماتی است و در حال بهبود آن هستیم_

## استفاده از ویرایشگر ساعت کاری

در یک گردش کاری معمولی ، شیءی که در حال ویرایش آن هستید یا دارای برچسب ساعات کاری (ساعات_باز کردن، زمانهای_سرویس و زمانهای_جمع آوری) است یا می توانید مجدداً از پیش تعیین شده برای شیء استفاده کنید تا فیلد ساعت خالی دریافت کند. اگر نیاز دارید که فیلد را به صورت دستی اضافه کنید و از وسپوچی استفاده می کنید، می توانید کلید را در صفحه جزئیات وارد کرده و سپس برای ویرایش به زبانه فرم برگردید. اگر معتقدید که برچسب ساعات کار باید بخشی از پیش تنظیم شده باشد ، لطفاً یک مسئله را برای ویرایشگر خود باز کنید.

اگر یک الگوی پیش فرض تعریف کرده اید (این کار را از طریق آیتم منوی "مدیریت الگوها" انجام دهید) وقتی ویرایشگر با مقدار خالی شروع به کار می کند، به طور خودکار بارگیری می شود. با عملکرد "بارگیری الگو" می توانید هر الگوی ذخیره شده را بارگیری کنید و با منوی "ذخیره الگو" می توانید مقدار فعلی را به عنوان یک الگو ذخیره کنید. شما می توانید الگوها و پیش فرض های جداگانه ای را برای کلید خاصی تعریف کنید، به عنوان مثال "ساعتهای_باز" ، "زمانهای_جمع آوری" و "زمانهای_سرویس" یا مقادیر سفارشی. علاوه بر این، می توانید کاربرد یک الگو را در یک منطقه و یک شناسه خاص، معمولاً یک برچسب سطح بالا OSM (به عنوان مثال امکانات رفاهی = رستوران) محدود کنید.

به طور طبیعی می توانید از ابتدا یک ساعت کار کنید، اما توصیه می کنیم از یکی از الگوهای موجود به عنوان نقطه شروع استفاده کنید.

هنگامی که یک مقدار ساعت کاری موجود بار می‌شود، برای پیروی از تعاریف فنی ساعت کاری، تلاشی برای اصلاح خودکار آن انجام می‌شود. اگر اصلاح خودکار میسر نشود، مکان تقریبی رخداد خطا در قسمت نمایش خام ساعت کاری، مشخص می‌شود و می‌توانید به‌طور دستی آن را اصلاح نمایید. تقریباً یک چهارم مقادیر OH در پایگاه داده اوپن‌استریت‌مپ مشکل دارند، اما کمتر از 10% قابل تصحیح نیست،[OpeningHoursParser](https://github.com/simonpoole/OpeningHoursParser) برای اطلاعات بیشتر در مورد اینکه چه انحرافی از مشخصات تحمل می شود.

### دکمهٔ منوی اصلی

* __افزودن قاعده__: قاعدهٔ جدیدی اضافه کنید.
* __افزودن قاعده برای تعطیلات__: برای تعطیلات و تغییر وضعیت آن قاعده‌ای اضافه کنید.
* __افزودن قانون برای 24/7__: یک قانون برای یک شیء که همیشه باز است اضافه کنید، مشخصات ساعات کار هیچ ارزش فرعی دیگری را برای 24/7 پشتیبانی نمی کند، اما ما اجازه می دهیم انتخاب کننده های سطح بالاتر (به عنوان مثال محدوده سال) اضافه شوند.
* __بارکردن الگو__: یک الگوی موجود را بار می‌کند.
* __ذخیره در الگو__: مقدار کنونی ساعت کاری را به‌عنوان الگو برای استفاده در آینده ذخیره کنید.
* __مدیریت قالب ها__: ویرایش، برای مثال تغییر نام، و حذف الگوهای موجود.
* __تازه‌سازی__: تجزیه و بررسی دوبارهٔ مقدار ساعت کاری
* __حذف همه__: همهٔ قواعد را حذف کنید.

### قواعد

قواعد پیشفرض به‌عنوان قاعدهٔ _عادی_ اضافه می‌شوند که یعنی بر مقادیر قاعده‌های قبلی برای همان روزها چیرگی دارند. هنگام استفاده از زمان‌های گسترده باید به این نکته توجه داشت. در این مواقع معمولاً باید نوع قاعده را با استفاده از گزینهٔ _نمایش نوع قاعده_ به _افزودنی_ تغییر دهید.

#### منوی قاعده

* __افزودن اصلاحگر/توضیح__: تأثیر قاعده را تغییر دهید و توضیح اختیاری اضافه کنید.
* __افزودن تعطیلات__: انتخابگر برای تعطیلات عمومی یا مدارس اضافه کنید.
* __افزودن بازهٔ زمان...__
    * __زمان - زمان__: زمان آغاز تا زمان پایان برای یک روز.
    * __ زمان - زمان طولانی__: زمان شروع تا پایان روز روز بعد (مثال 26:00 ساعت 02:00  (ق.ظ.) در روز بعد).
    * __زمان متغیر - زمان__: از زمان متغیر شروع (سپیده دم، غروب، طلوع خورشید و غروب آفتاب) تا زمان پایان در همان روز.
    * __زمان متغیر - زمان گسترده__: از زمان آغاز غیرثابت تا زمان پایان در روز بعد.
    * __زمان - زمان متغیر__: زمان آغاز تا زمان پایان غیرثابت.
    * __زمان متغیر - زمان متغیر__: زمان آغاز غیرثابت تا زمان پایان غیرثابت.
    * __زمان__: لحظه‌ای در زمان.
    * __زمان-پایان باز__: از یک لحظهٔ آغاز به بعد.
    * __زمان متغیر__: در زمان غیرثابت مشخص
    * __زمان متغیر-پایان باز__: از یک زمان آغاز غیرثابت به بعد
* __افزودن بازهٔ روز هفته__: انتخابگری بر اساس هفته اضافه کنید.
* __افزودن بازهٔ تاریخ...__
    * __تاریخ - تاریخ__: از تاریخ آغاز (سال، ماه، روز) تا تاریخ پایان.
    * __تاریخ متغیر - تاریخ__: از تاریخ آغاز غیرثابت (فعلاً در تعارف فنی فقط _easter_ آمده است) تا تاریخ پایان.
    * __تاریخ - تاریخ متغیر__: از تاریخ آغاز تا تاریخ غیرثابت.
    * __تاریخ متغیر - تاریخ متغیر__: از تاریخ آغاز غیرثابت تا تاریخ پایان غیرثابت.
    * __وقوع در ماه - وقوع در ماه__: از وقوع یک روز هفته در ماه تا همان روز.
    * __وقوع در ماه - تاریخ__: از وقوع یک روز هفته در ماه تا تاریخ پایان.
    * __تاریخ - وقوع در ماه__: از تاریخ آغاز تا وقوع یک روز هفته در ماه.
    * __وقوع در ماه - تاریخ متغیر__: از وقوع یک روز هفته در ماه تا تاریخ پایان غیرثابت.
    * __تاریخ متغیر - وقوع در ماه__: از تاریخ آغاز غیرثابت تا وقوع یک روز هفته در ماه.
    * __تاریخ - پایان باز__: از تاریخ آغاز به بعد.
    * __تاریخ متغیر - پایان باز__: از تاریخ آغاز غیرثابت به بعد.
    * __وقوع در ماه - پایان باز__: از وقوع یک روز هفته در ماه به بعد.
    * __با آفست...__: همان مدخل‌هایی که پیشتر گفته شد با مشخص‌کردن آفست (به‌ندرت استفاده می‌شود).
* __افزودن محدوده سال ...__
    * __افزودن بازهٔ سال__: انتخابگری بر اساس سال اضافه کنید.
    * __افزایش سال شروع__: محدوده سال پایان باز را اضافه کنید.
* __افزودن بازهٔ هفته__: انتخابگری بر اساس شمارهٔ هفته اضافه کنید.
* __تکرار__: از این قاعده کپی بگیرید و پس از موقعیت کنونی درج کنید.
* __نمایش نوع قانون__: نمایش و اجازه تغییر نوع قانون _ عادی_ ، _افزودنی_ و _پاسخ_ (در قانون اول موجود نیست).
* __برو بالا__: این قاعده را یک پله بالا ببرید (برای قاعدهٔ اول امکان‌پذیر نیست).
* __برو پایین__: این قاعده را یک پله پایین ببرید.
* __حذف__: این قاعده را حذف کنید.

### بازه‌های زمان

برای سهولت هرچه بیشتر بازه های زمانی ویرایش، سعی می کنیم هنگام بارگذاری مقادیر موجود، محدوده زمانی مطلوب و جزئیات را برای نوارهای محدوده انتخاب کنیم. برای بازه های زمانی جدید، میله ها از ساعت 6 صبح (صبح) شروع می شوند و 15 دقیقه افزایش دارند، این را می توان از طریق منو تغییر داد.

اگر استفادهٔ مستقیم از نوارها خیلی دشوار است، با زدن روی نوار زمان (نه روی دسته‌ها) زمان‌گزین بزرگ باز می‌شود. زمان‌گزین‌ها به روز بعد گسترش می‌یابند، بنابراین راه ساده‌ای برای گسترش بازهٔ زمان هستند بدون اینکه مجبور باشید بازه را حذف و دوباره اضافه کنید.

#### منوی بازهٔ زمان

* __نمایش زمان گیر__: برای انتخاب زمان آغاز و پایان یک کادر بزرگ نمایش می‌دهد. در نمایشگرهای خیلی کوچک روش مناسبی برای تغییر زمان است.
* __ تغییر به تیک های 15 دقیقه __: از دانه بندی 15 دقیقه ای برای نوار محدوده استفاده کنید.
* __ تغییر به خط‌نشان‌های 5 دقیقه__: از گام‌های 5 دقیقه ای برای نوار محدوده استفاده کنید.
* __پرش به خط‌نشان‌های ۱ دقیقه‌ای__: استفاده از گام‌های ۱ دقیقه‌ای برای نوار بازه. استفاده روی گوشی خیلی راحت نیست.
* __آغاز از نیمه‌شب__: نوار بازه از نیمه‌شب آغاز می‌شود.
* __نمایش دوره__: برای مشخص‌کردن دوره به دقیقه خانهٔ دوره را نمایش می‌دهد.
* __حذف__: این بازهٔ زمان را حذف کنید.

### مدیریت الگوها

گفتگوی مدیریت قالب به شما امکان می دهد قالب ها را اضافه، ویرایش و حذف کنید.

در اندروید 4.4 و بالاتر قابلیت های زیر زیر از دکمه منو موجود است.

* __ نمایش همه __: نمایش همه قالب ها در پایگاه داده.
* __ ذخیره در فایل__: محتویات پایگاه داده قالب را در یک فایل بنویسید.
* __ بارگیری از فایل (جایگزینی) __: بارگذاری قالب ها از یک فایل که جایگزین محتویات فعلی پایگاه داده می شود.
* __ بارگیری از فایل__: بارگذاری قالب ها از یک فایل که محتویات فعلی را حفظ می کند.

#### گفتگوهای قالب را ذخیره و ویرایش کنید

گفتگو به شما امکان می دهد تنظیم کنید

* __ نام__ نام توصیفی برای الگو.
* __ پیش فرض__ اگر علامت زده شود به عنوان یک الگوی پیش فرض در نظر گرفته می شود (معمولاً توسط سایر زمینه ها بیشتر محدود می شود).
* __ کلید__ کلیدی که این الگو برای آن مناسب است ، اگر روی _کلید پیشفرض_ تنظیم شده باشد، می توانید یک مقدار غیر استاندارد را در قسمت زیر اضافه کنید. مقادیر کلیدی از کارت های wild SQL پشتیبانی می کند، یعنی _٪ _ با صفر یا بیشتر کاراکتر مطابقت دارد، * _ * با یک کاراکتر واحد مطابقت دارد. هر دو کاراکتر کارت وحشی را می توان با _\\_ برای مطابقت واقعی فرار کرد.
* __منطقه__ منطقه ای که قالب برای آن قابل اجرا است.
* __شی__ یک رشته کاربردی خاص برای مطابقت. 

