# עורך שעות הפתיחה של OpenStreetMap

מפרט שעות הפתיחה של OpenStreetMap הוא די מורכב ולא מסביר פנים בהיבט של מנשק משתמש פשוט וברור.

עם זאת, סביר להניח שברוב הזמן יידרש לך רק חלק מצומצם מתוך המנגנון. העורך לוקח זאת בחשבון תוך הסתרת תכונות שאינן שימושיות בתפריטים וברוב המקרים מצמצם את השימוש השוטף להתאמות קטנות של תבניות מותאמות אישית.

_תיעוד זה הוא ראשוני בלבד וכרגע מתבצעות עליו עבודות עריכה נוספות_

## שימוש בעורך שעות הפתיחה

במצב עבודה טיפוסי לפריט שבחרת לערוך כבר יש תגית שעות פתיחה (opening_hours,‏ service_times ו־collection_times) או שניתן להחיל מחדש את הערכה עבור הפריט כדי לקבל שדה שעות פתיחה ריק. אם יש לך צורך בהוספת השדה ידנית וניסית לעשות זאת דרך וספוצ׳י ניתן להקליד את שם המפתח בעמוד הפרטים ואז לחזור ללשונית מבוססת הטפסים לטובת עריכה. אם לדעתך תגית שעות הפתיחה אמורה להיות חלק מהערכה הראשונית, נא לדווח על תקלה כנגד העורך שלך.

אם הגדרת תבנית בררת מחדל (אפשר לעשות את זה דרך הפריט „ניהול תבניות” בתפריט) היא תיטען אוטומטית עם הפעלת העורך עם ערך ריק. בעזרת הפונקציה „טעינת תבנית” אפשר לטעון כל תבנית שמורה שהיא ועם התפריט „שמירת תבנית” אפשר לשמור את הערך הנוכחי כתבנית. אפשר להגדיר תבניות נפרדות ובררות מחדל למפתח מסוים, למשל „opening_hours”,‏ „collection_times” ו־„service_times” או ערכים משלך. נוסף על כך, ניתן להגביל את היכולת להחיל תבנית על איזור ומזהה מסוים, בדרך כלל תגית ברמה עליונה של OSM (למשל amenity=restaurant).

באופן טבעי ניתן להרכיב ערך שעות פתיחה מאפשר, אך אנו ממליצים להשתמש באחת מהתבניות הקיימות כנקודת התחלה.

אם נטען ערך קיים של שעות פתיחה, מתבצע ניסיון לתקן אותו אוטומטית כדי להתאים למפרט שעות הפתיחה. אם פעולה כזו אינה אפשרית המיקום בקירוב בו התרחשה השגיאה יודגש בתצוגה של ערכי שעות הפתיחה הגולמיים ותהיה לך אפשרות לנסות ולתקן זאת ידנית. בערך ברבע מערכי שעות הפתיחה במסד הנתונים של OpenStreetMap יש תקלות אך פחות מ־10% אינן ניתנות לתיקון, יש לעיין בערך [OpeningHoursParser](https://github.com/simonpoole/OpeningHoursParser) (מנתח שעות פתיחה) לקבלת מידע נוסף על אילו סטיות מהמפרט נסבלות.

### כפתור תפריט ראשי

* __הוספת כלל__: הוספת כלל חדש.
* __הוספת כלל לחגים__: הוספת כלל חדש לחג יחד עם שינוי מצב.
* __הוספת כלל ל־24/7__: הוספת כלל לפריט שתמיד פתוח, מפרט שעות הפתיחה לא תומך בערכים נגזרים עבור 24/7 עם זאת אנו מאפשרים הוספת בוררים ברמה גבוהה יותר (למשל: טווח שנים).
* __טעינת תבנית__: טעינת תבנית קיימת.
* __שמירה לתבנית__: שמירת ערך שעות הפתיחה הנוכחי כתבנית לשימוש עתידי.
* __ניהול תבניות__: עריכה, למשל שינוי השם ומחיקה של תבניות קיימות.
* __רענון__: פענוח ערך שעות הפתיחה מחדש.
* __מחיקת הכול__: הסרת כל הכללים.

### כללים

כללי בררת המחדל נוספו ככללים מסוג _רגיל_, הגדרה זו מרמזת על כך שהם יידרסו על ידי הערכים של הכללים הקודמים עבור אותם ימים. מצב זה עשוי להדאיג בהגדרת זמנים מורחבים, במיוחד עקב החלפת כללים דרך רשומת התפריט _הצגת סוג כלל_ לכלל _מתווסף_.

#### תפריט כללים

* __הוספת מצב/תגובה__: שינוי ההשפעה של הכלל הזה והוספת תגובה כרשות.
* __הוספת חג__: הוספת בורר לחגים ציבוריים או חגי בית ספר.
* __הוספת טווח זמן…__
    * __שעה - שעה__: שעת התחלה עד שעת סיום באותו היום.
    * __שעה - שעה מורחבת__: שעת התחלה עד שעת סיום ביום שלמחרת (למשל: 26:00 זה 02:00 לפנות בוקר ביום הבא).
    * __שעה משתנה - שעה__: משעת התחלה משתנה (שחר, דמדומים, זריחה ושקיעה) עד לשעת סיום באותו היום.
    * __שעה משתנה - שעה מורחבת__: משעת התחלה משתנה ועד לשעת סיום ביום שלמחרת.
    * __שעה - שעה משתנה__: שעת התחלה עד שעת סיום משתנה.
    * __שעה משתנה - שעה משתנה__: שעת התחלה משתנה עד שעת סיום משתנה.
    * __שעה__: נקודה בזמן.
    * __שעה - הודעה חדשה__: מנקודת התחלה בזמן ואילך.
    * __שעה משתנה__: בשעה משתנה
    * __שעה משתנה - הודעה חדשה__: משעת התחלה משתנה ואילך
* __הוספת טווח ימים בשבוע__: הוספת בורר על סמך ימים בשבוע.
* __הוספת טווח תאריכים…__
    * __תאריך - תאריך__: מתאריך התחלה (שנה, חודש, יום) עד לתאריך סיום.
    * __תאריך משתנה - תאריך__: מתאריך התחלה משתנה (כרגע המפרט מגדיר רק את _פסחא_) עד לתאריך סיום.
    * __תאריך - תאריך משתנה__: מתאריך התחלה ועד תאריך משתנה.
    * __תאריך משתנה - תאריך משתנה__: מתאריך התחלה משתנה עד תאריך סיום משתנה.
    * __פעם בחודש - פעם בחודש__: החל ממופע של יום בשבוע מתוך חודש עד לאחד נוסף כזה.
    * __פעם בחודש - תאריך__: החל ממופע של יום בשבוע מתוך חודש עד לתאריך סיום.
    * __תאריך - פעם בחודש__: מתאריך התחלה עד מופע של יום בשבוע מתוך חודש.
    * __פעם בחודש - תאריך משתנה__: החל ממופע של יום בשבוע מתוך חודש עד לתאריך סיום משתנה.
    * __תאריך משתנה - פעם בחודש__: מתאריך התחלה משתנה עד מופע של יום בשבוע מתוך חודש.
    * __שעה - הודעה חדשה__: משעה מסוימת ואילך.
    * __תאריך משתנה - הודעה חדשה__: מתאריך התחלה משתנה ואילך.
    * __פעם בחודש - הודעה חדשה__: החל ממופע של יום בשבוע מתוך חודש ואילך.
    * __עם איזונים…__: אותן הרשומות כלעיל רק עם איזונים (בקושי בשימוש).
* __הוספת טווח שנים…__    
    * __הוספת טווח שנים__: הוספת בורר לבחירת שנים.
    * __הוספת שנת התחלה__: הוספת טווח שנים עם סוף פתוח.
* __הוספת טווח שבועות__: הוספת בורר לבחירת מספרי שבועות.
* __שכפול__: יצירת עותק של הכלל הזה והוספתו לאחר המיקום הנוכחי.
* __הצגת סוג כלל__: להציג ולאפשר לשנות את סוג הכלל _רגיל_, _מתווסף_ ו_עתודה_ (לא זמין בתור הכלל הראשון).
* __העברה למעלה__: העלאת הכלל הזה בשורה אחת למעלה (לא זמין עבור הכלל הראשון).
* __העברה למטה__: הורדת הכלל הזה בשורה אחת למטה.
* __מחיקה__: מחיקת הכלל הזה.

### טווחי שעות

כדי להקל על עריכת טווי שעות עד כמה שניתן, אנו מנסים לבחור טווח שעות מיטבי ויכולת בחירה מוגדרת עבור סרגלי הטווח בעת טעינת ערכים קיימים. לטווחי שעות חדשים, הסרגלים מתחילים ב־6:00 בבוקר וניתן להגדיל ב־15 דקות בכל צעד, ניתן לשנות זאת דרך התפריט.

לחיצה (לא על הנעצים) על סרגל הזמן פותחת את בורר הזמן הגדול, כאשר השימוש הישיר בסרגלים הוא מסובך מדי. בוררי הזמן מתרחבים ליום הבא, לכן הם מעניקים דרך פשוטה להרחיב טווח זמן מבלי למחוק ולהוסיף את הטווח מחדש.

#### תפריט טווחי שעות

* __הצגת בורר זמן__: הצגת בורר זמן גדול לבחירת זמן התחלה וסיום, בתצוגות קטנות מאוד זו הדרך המועדפת לעריכת זמנים.
* __מעבר לפעימות של 15 דקות__: להשתמש בדיוק של 15 דקות עבור סרגל הטווח.
* __מעבר לפעימות של 5 דקות__: להשתמש בדיוק של 5 דקות עבור סרגל הטווח.
* __מעבר לפעימות של דקה__: להשתמש בדיוק של דקה עבור סרגל הטווח, לא נוח לשימוש בטלפון.
* __התחלה בחצות__: התחלת סרגל הטווח בחצות.
* __הצגת הפרש__: הצגת שדה ההפרש לציון הפרש בדקות.
* __מחיקה__: מחיקת טווח הזמן הזה.

### ניהול תבניות

חלונית ניהול התבניות הזאת מאפשרת לך להוסיף, לערוך ולמחוק תבניות.

ב־Android 4.4 ומעלה היכולת הנוספת הבאה זמינה מכפתור התפריט.

* __הצגה של הכול__: הצגת כל התבניות במסד הנתונים.
* __שמירה לקובץ__: כתיבת תכני מסד נתוני התבניות לקובץ.
* __טעינה מקובץ (החלפה)__: טעינת תבניות מקובץ שמחליפה את התוכן הנוכחי של מסד הנתונים.
* __טעינה מקובץ__: טעינת תבניות מקובץ תוך שימור התכנים הנוכחיים.

#### לשמור ולערוך חלוניות תבניות

החלונית מאפשרת לך להגדיר

* __שם__ שם ייצוגי לתבנית.
* __בררת מחדל__ אם מסומן, זאת תיחשב לתבנית בררת המחדל (בדרך כלל מקובע אף יותר על ידי השדות האחרים).
* __מפתח__ המפתח שהתבנית הזו מתאימה לו, אם מוגדר לכדי _מפתח אישי_ אפשר להוסיף ערך מחוץ לתקן בשדה שלהלן. ערכי המפתח תומכים בתווים כוללניים של SQL, כאשר _%_ לוכד אפס תווים או יותר, *_* לוכד תו יחיד. את שני התווים הכוללניים אפשר להחריג באמצעות _\\_ ללכידה כפי שהם.
* __אזור__ האזור עליו חלה התבנית.
* __פריט__ מחרוזת ייעודית ליישום לשימוש עבור התאמה.

